/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StainingProtocols;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_StainingProtocols;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;

/**
 * This class represents StainingProtocols CID8130
 */
public class StainingProtocols_CID8130 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new StainingProtocols_CID8130 Template 
	 */
	public StainingProtocols_CID8130()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumStainingProtocols Object of EnumCM_StainingProtocols represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_StainingProtocols enumStainingProtocols)
	{
		switch(enumStainingProtocols) 
		{
		case STAINING: this.strCodeValue =EnumCV_StainingProtocols.STAINING_P3_00003.getValue(); break;
		case HEMATOXYLIN_AND_EOSIN_STAIN_METHOD: this.strCodeValue =EnumCV_StainingProtocols.HEMATOXYLIN_AND_EOSIN_STAIN_METHOD_P3_50495.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumStainingProtocols Object of EnumCM_StainingProtocols represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_StainingProtocols enumStainingProtocols)
	{
		switch(enumStainingProtocols)
		{
		case STAINING : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.STAINING.getSNOMEDCTID(); break;
		case HEMATOXYLIN_AND_EOSIN_STAIN_METHOD : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.HEMATOXYLIN_AND_EOSIN_STAIN_METHOD.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for StainingProtocols
	 * @param enumStainingProtocols Object of EnumCM_StainingProtocols.
	 */
	public void setStainingProtocols(EnumCM_StainingProtocols enumStainingProtocols)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumStainingProtocols.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumStainingProtocols);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumStainingProtocols);
	}
}
